package com.galaxis.manatee.webservice;


import com.galaxis.manatee.chuanyun_web_service.*;
import com.galaxis.manatee.task.ChuanyunHumanResourceScheduledTask;
import lombok.extern.slf4j.Slf4j;
import org.springframework.ws.server.endpoint.annotation.Endpoint;
import org.springframework.ws.server.endpoint.annotation.PayloadRoot;
import org.springframework.ws.server.endpoint.annotation.RequestPayload;
import org.springframework.ws.server.endpoint.annotation.ResponsePayload;

/**
 * @author kxuan
 * @version 1.0
 */
@Slf4j
@Endpoint
public class CountryEndpoint {
	private static final String NAMESPACE_URI = "http://galaxis.com/manatee/chuanyun-web-service";

	private final ChuanyunHumanResourceScheduledTask chuanyunHumanResourceScheduledTask;

	public CountryEndpoint(ChuanyunHumanResourceScheduledTask chuanyunHumanResourceScheduledTask) {
		this.chuanyunHumanResourceScheduledTask = chuanyunHumanResourceScheduledTask;
	}


	@PayloadRoot(namespace = NAMESPACE_URI, localPart = "GetSchema")
	@ResponsePayload
	public GetSchemaResponse getSchema(@RequestPayload GetSchema request)
	{
		GetSchemaResponse getSchemaResponse=new GetSchemaResponse();
		getSchemaResponse.setResponse("{}");
		return getSchemaResponse;
	}

	@PayloadRoot(namespace = NAMESPACE_URI, localPart = "GetSchemaList")
	@ResponsePayload
	public GetSchemaListResponse getSchemaList(@RequestPayload GetSchemaList request)
	{
		GetSchemaListResponse getSchemaListResponse=new GetSchemaListResponse();
		getSchemaListResponse.setResponse("{}");
		return getSchemaListResponse;
	}

	@PayloadRoot(namespace = NAMESPACE_URI, localPart = "GetList")
	@ResponsePayload
	public GetListResponse getList(@RequestPayload GetList request) {
		GetListResponse getListResponse=new GetListResponse();
		getListResponse.setResponse("{}");
		return getListResponse;
	}

	/**
	 * 氚云后端调用的方法名
	 */
	@PayloadRoot(namespace = NAMESPACE_URI, localPart = "Invoke")
	@ResponsePayload
	public InvokeResponse invoke(@RequestPayload Invoke request) {
        //书写调用第三方接口方法
		log.info(request.getMethodName()+"----"+request.getParam()+"----"+request.getSchemaCode());
		InvokeResponse invokeResponse=new InvokeResponse();
		chuanyunHumanResourceScheduledTask.getPayrollManually();
		log.info("更新薪酬项成功");
		invokeResponse.setResponse("{}");
		return invokeResponse;
	}
}
